#include "Barra.h"

Barra::Barra(char tipo, int quantBonecos, int posX, int posY, int lado) {
          
          this->posX = posX;
          this->posY = posY;
          this->quantBonecos = quantBonecos;
          this->contChute = 0;
          this->cima = false;
          this->baixo = false;
          this->chute = false;
          this->toque = false;
          this->tipo = tipo;
          this->lado = lado;
          this->bonecos = new Boneco[quantBonecos];
          this->colisao = false;//PAULO
          
          this->geraBonecos();
                
}

void Barra::geraBonecos() {
     if(lado == 1){
     
     if(this->tipo == 'G') {//goleiro
          Boneco *c =  new Boneco(this->posY + 260/*240*/, this->posY + 264, this->posY + 270, this->posX + 42) ;        
          this->bonecos[0] = *c;
                                
     
     }else if(this->tipo == 'D') { //defesa
         Boneco *b = new Boneco(this->posY + 176/*156*/, this->posY + 180, this->posY + 186, this->posX + 48);
         Boneco *b2 = new Boneco(this->posY + 353/*334*/, this->posY + 357, this->posY + 363, this->posX + 48);  
         this->bonecos[0] = *b;
         this->bonecos[1] = *b2;            
     
     }else if(this->tipo == 'M') { //meio de campo
           Boneco *m1 = new Boneco(this->posY + 164/*143*/, this->posY + 168, this->posY + 174, this->posX + 39);
           Boneco *m2 = new Boneco(this->posY + 236/*219*/, this->posY + 240, this->posY + 246, this->posX + 39);
           Boneco *m3 = new Boneco(this->posY + 309/*294*/, this->posY + 313, this->posY + 319, this->posX + 39);
           Boneco *m4 = new Boneco(this->posY + 376/*364*/, this->posY + 380, this->posY + 384, this->posX + 39);
           Boneco *m5 = new Boneco(this->posY + 440/*429*/, this->posY + 444, this->posY + 450, this->posX + 39);  
           this->bonecos[0] = *m1;
           this->bonecos[1] = *m2;
           this->bonecos[2] = *m3;
           this->bonecos[3] = *m4;
           this->bonecos[4] = *m5;
           
     } else if(this->tipo == 'A') { //ataque
         Boneco *a1 = new Boneco(this->posY + 123/*104*/, this->posY + 127, this->posY + 133, this->posX + 43);
         Boneco *a2 = new Boneco(this->posY + 243/*224*/, this->posY + 247, this->posY + 253, this->posX + 43);
         Boneco *a3 = new Boneco(this->posY + 362/*343*/, this->posY + 366, this->posY + 372, this->posX + 43);   
         this->bonecos[0] = *a1;
         this->bonecos[1] = *a2;
         this->bonecos[2] = *a3;                         
           
           
     }
     }else if(lado == 2) {
           
     if(this->tipo == 'G') {//goleiro
          Boneco *c =  new Boneco(this->posY + 336/*240*/, this->posY + 340, this->posY + 346, this->posX + 49) ;        
          this->bonecos[0] = *c;
                                
     
     }else if(this->tipo == 'D') { //defesa
         Boneco *b = new Boneco(this->posY + 252/*156*/, this->posY + 256, this->posY + 262, this->posX + 47);
         Boneco *b2 = new Boneco(this->posY + 429/*334*/, this->posY + 433, this->posY + 439, this->posX + 47);  
         this->bonecos[0] = *b;
         this->bonecos[1] = *b2;            
     
     }else if(this->tipo == 'M') { //meio de campo
           Boneco *m1 = new Boneco(this->posY + 155/*143*/, this->posY + 159, this->posY + 165, this->posX + 51);
           Boneco *m2 = new Boneco(this->posY + 221/*219*/, this->posY + 225, this->posY + 231, this->posX + 51);
           Boneco *m3 = new Boneco(this->posY + 287/*294*/, this->posY + 291, this->posY + 297, this->posX + 51);
           Boneco *m4 = new Boneco(this->posY + 360/*364*/, this->posY + 364, this->posY + 370, this->posX + 51);
           Boneco *m5 = new Boneco(this->posY + 432/*429*/, this->posY + 436, this->posY + 442, this->posX + 51);  
           this->bonecos[0] = *m1;
           this->bonecos[1] = *m2;
           this->bonecos[2] = *m3;
           this->bonecos[3] = *m4;
           this->bonecos[4] = *m5;
           
     } else if(this->tipo == 'A') { //ataque
         Boneco *a1 = new Boneco(this->posY + 234/*104*/, this->posY + 238, this->posY + 244, this->posX + 48);
         Boneco *a2 = new Boneco(this->posY + 353/*224*/, this->posY + 357, this->posY + 363, this->posX + 48);
         Boneco *a3 = new Boneco(this->posY + 471/*343*/, this->posY + 475, this->posY + 481, this->posX + 48);   
         this->bonecos[0] = *a1;
         this->bonecos[1] = *a2;
         this->bonecos[2] = *a3;                         
           
           
     }
                 
           
     }
     

}   

void Barra::carregaImagensBarra(char nomeTime, int lado) {
     
       if(lado == 1) {
          
          if(nomeTime == 'B') {
          
                if(this->tipo == 'G') {
                      this->imagem[0] = load_bitmap("imagens\\BrasilGoleiro01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\BrasilGoleiro02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\BrasilGoleiro03.bmp", this->paletaBarra);
                }else if(this->tipo == 'D') {
                      this->imagem[0] = load_bitmap("imagens\\BrasilDefesa01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\BrasilDefesa03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\BrasilDefesa02.bmp", this->paletaBarra);                        
                }else if(this->tipo == 'M') {
                      this->imagem[0] = load_bitmap("imagens\\BrasilMeioCampo01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\BrasilMeioCampo03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\BrasilMeioCampo02.bmp", this->paletaBarra);
                }else if(this->tipo == 'A') {
                      this->imagem[0] = load_bitmap("imagens\\BrasilAtaque01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\BrasilAtaque02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\BrasilAtaque03.bmp", this->paletaBarra);
                }
                
          }else if(nomeTime == 'A') {
          
                if(this->tipo == 'G') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha2\\AlemanhaGoleiro01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha2\\AlemanhaGoleiro03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha2\\AlemanhaGoleiro02.bmp", this->paletaBarra);
                }else if(this->tipo == 'D') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha2\\AlemanhaDefesa01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha2\\AlemanhaDefesa02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha2\\AlemanhaDefesa03.bmp", this->paletaBarra);                        
                }else if(this->tipo == 'M') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha2\\AlemanhaMeioCampo01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha2\\AlemanhaMeioCampo02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha2\\AlemanhaMeioCampo03.bmp", this->paletaBarra);
                }else if(this->tipo == 'A') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha2\\AlemanhaAtaque01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha2\\AlemanhaAtaque03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha2\\AlemanhaAtaque02.bmp", this->paletaBarra);
                }
          }
                
          
       }else if(lado == 2) { 
             
             if(nomeTime == 'B') {
          
                if(this->tipo == 'G') {
                      this->imagem[0] = load_bitmap("imagens\\Brasil\\BrasilGoleiro01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Brasil\\BrasilGoleiro02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Brasil\\BrasilGoleiro03.bmp", this->paletaBarra);
                }else if(this->tipo == 'D') {
                      this->imagem[0] = load_bitmap("imagens\\Brasil\\BrasilDefesa01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Brasil\\BrasilDefesa03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Brasil\\BrasilDefesa02.bmp", this->paletaBarra);                        
                }else if(this->tipo == 'M') {
                      this->imagem[0] = load_bitmap("imagens\\Brasil\\BrasilMeioCampo01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Brasil\\BrasilMeioCampo03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Brasil\\BrasilMeioCampo02.bmp", this->paletaBarra);
                }else if(this->tipo == 'A') {
                      this->imagem[0] = load_bitmap("imagens\\Brasil\\BrasilAtaque01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Brasil\\BrasilAtaque02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Brasil\\BrasilAtaque03.bmp", this->paletaBarra);
                }
             
             }else if(nomeTime == 'A') {
          
                if(this->tipo == 'G') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha\\AlemanhaGoleiro01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha\\AlemanhaGoleiro03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha\\AlemanhaGoleiro02.bmp", this->paletaBarra);
                }else if(this->tipo == 'D') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha\\AlemanhaDefesa01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha\\AlemanhaDefesa02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha\\AlemanhaDefesa03.bmp", this->paletaBarra);                        
                }else if(this->tipo == 'M') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha\\AlemanhaMeioCampo01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha\\AlemanhaMeioCampo02.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha\\AlemanhaMeioCampo03.bmp", this->paletaBarra);
                }else if(this->tipo == 'A') {
                      this->imagem[0] = load_bitmap("imagens\\Alemanha\\AlemanhaAtaque01.bmp", this->paletaBarra);
                      this->imagem[1] = load_bitmap("imagens\\Alemanha\\AlemanhaAtaque03.bmp", this->paletaBarra);
                      this->imagem[2] = load_bitmap("imagens\\Alemanha\\AlemanhaAtaque02.bmp", this->paletaBarra);
                }
            }
       }
             

}

BITMAP* Barra::geraImagemBarra(int time) {
        BITMAP *imagem; 
        if(this->cima == true) {
             if(this->colisaoBarraMadeiraCima(time) == false) {
                  this->posY = this->posY - 4;
                  this->setaPosicaoBonecos(4);
             }
             imagem = this->imagem[0];
           
        }if(this->baixo == true) {
             if(this->colisaoBarraMadeiraBaixo(time) == false) {
                  this->posY = this->posY + 4;
                  this->setaPosicaoBonecos(4);
             } 
             imagem = this->imagem[0];
        }
        
        
        if(this->chute == true) {
             imagem = this->imagem[2];
        }
        
        if(this->toque == true ) {
             imagem = this->imagem[1];
        }
        
        if(this->cima == false && this->baixo == false && this->chute == false
             && this->toque == false) {
             imagem = this->imagem[0];
        }      
        return imagem;
                
}


void Barra::setaPosicaoBonecos(int cont) {
     if(this->cima == true) {
         this->bonecos[0].posY_esq = this->bonecos[0].posY_esq - cont;
         if(this->tipo == 'D') {
            this->bonecos[1].posY_esq = this->bonecos[1].posY_esq - cont;
         }else if(this->tipo == 'M') {
             this->bonecos[1].posY_esq = this->bonecos[1].posY_esq - cont;
             this->bonecos[2].posY_esq = this->bonecos[2].posY_esq - cont;
             this->bonecos[3].posY_esq = this->bonecos[3].posY_esq - cont;
             this->bonecos[4].posY_esq = this->bonecos[4].posY_esq - cont;
         }else if(this->tipo == 'A') {
             this->bonecos[1].posY_esq = this->bonecos[1].posY_esq - cont;
             this->bonecos[2].posY_esq = this->bonecos[2].posY_esq - cont;
         }
     }else if(this->baixo == true) {
          this->bonecos[0].posY_esq = this->bonecos[0].posY_esq + cont;
         if(this->tipo == 'D') {
            this->bonecos[1].posY_esq = this->bonecos[1].posY_esq + cont;
         }else if(this->tipo == 'M') {
             this->bonecos[1].posY_esq = this->bonecos[1].posY_esq + cont;
             this->bonecos[2].posY_esq = this->bonecos[2].posY_esq + cont;
             this->bonecos[3].posY_esq = this->bonecos[3].posY_esq + cont;
             this->bonecos[4].posY_esq = this->bonecos[4].posY_esq + cont;
         }else if(this->tipo == 'A') {
             this->bonecos[1].posY_esq = this->bonecos[1].posY_esq + cont;
             this->bonecos[2].posY_esq = this->bonecos[2].posY_esq + cont;
         }
         
     }      
     
}

bool Barra::colisaoBarraMadeiraCima(int time) {
     //    bool colisao = false;
         this->colisao = false;
         if(time == 1) {
             if(this->tipo == 'G') {
                 if(this->posY < -12) {
                     colisao = true;
                 }
             }else if(this->tipo == 'A') {
                 if(this->posY < 25) {
                     colisao = true;
               }     
             }else if(this->tipo == 'D') {
                 if(this->posY < -32) {
                     colisao = true;
                 }         
             }else  {
                 if(this->posY < -17) {
                     colisao = true;
                 }         
             }
         }else {
              
              if(this->tipo == 'G') {
                 if(this->posY < -86) {
                     colisao = true;
                 }
             }else if(this->tipo == 'A') {
                 if(this->posY < -86) {
                     colisao = true;
               }     
             }else if(this->tipo == 'D') {
                 if(this->posY < -104) {
                     colisao = true;
                 }         
             }else  {
                 if(this->posY < -10) {
                     colisao = true;
                 }         
             }
         }
               
         return colisao;                                                    
}

bool Barra::colisaoBarraMadeiraBaixo(int time) {
         bool colisao = false;
         if(time == 1) {
             if(this->tipo == 'G') {
                 if(this->posY > 117) {
                     colisao = true;
                 }
             }else if(this->tipo == 'A') {
                 if(this->posY > 118) {
                     colisao = true;
                 }     
             }else if(this->tipo == 'D') {
                 if(this->posY > 126) {
                     colisao = true;
                 }         
             }else  {
                 if(this->posY > 38) {
                     colisao = true;
                 }
             }         
         }else {
               
               if(this->tipo == 'G') {
                 if(this->posY > 43) {
                     colisao = true;
                 }
             }else if(this->tipo == 'A') {
                 if(this->posY > 12) {
                     colisao = true;
                 }     
             }else if(this->tipo == 'D') {
                 if(this->posY > 52) {
                     colisao = true;
                 }         
             }else  {
                 if(this->posY > 44) {
                     colisao = true;
                 }
             }
         }         
          
         return colisao;                                                    
}

        
            
