#include "Jogo.h"
#include <Math.h>
#include <time.h>


Jogo::Jogo(char time1, char time2) {

      this->carregaCampo();
      this->time1 = new Time(1, time1, 111, 45, 196, 45, 378, 15, 559, 75);
      this->time2 = new Time(2, time2, 740, -20, 639, -25, 462, 0, 280, -40);
      this->bola  = new Bola(700, 350, 15); //paulo -210  
      this->selAutomaticaTime1 = true;
      this->selAutomaticaTime2 = false;
      this->habilitaChuteTime01 = false;  

      this->colidiuT1 = false;
      this->colidiuT2 = false;
}
 
Jogo::~Jogo() {
      delete[] this->gramado;
      delete[] this->madeiraBaixo;
      delete[] this->madeiraCima;
      delete[] this->telaAtualJogo;
     
} 

void Jogo::carregaCampo() {

       this->gramado = load_bitmap("imagens\\campoOficial.bmp", this->paletaJogo);
       this->madeiraBaixo = load_bitmap("imagens\\madeiraBaixo.bmp", this->paletaJogo);
       this->madeiraCima = load_bitmap("imagens\\madeiraCima.bmp", this->paletaJogo);
       
       this->placar[0] = load_bitmap("imagens\\Placar\\PlacarN0.bmp", this->paletaJogo);
       this->placar[1] = load_bitmap("imagens\\Placar\\PlacarN1.bmp", this->paletaJogo);
       this->placar[2] = load_bitmap("imagens\\Placar\\PlacarN2.bmp", this->paletaJogo);
       this->placar[3] = load_bitmap("imagens\\Placar\\PlacarN3.bmp", this->paletaJogo);
       this->placar[4] = load_bitmap("imagens\\Placar\\PlacarN4.bmp", this->paletaJogo);
       this->placar[5] = load_bitmap("imagens\\Placar\\PlacarN5.bmp", this->paletaJogo);
       this->placar[6] = load_bitmap("imagens\\Placar\\PlacarN6.bmp", this->paletaJogo);
       this->placar[7] = load_bitmap("imagens\\Placar\\PlacarN7.bmp", this->paletaJogo);
       this->placar[8] = load_bitmap("imagens\\Placar\\PlacarN8.bmp", this->paletaJogo);
       this->placar[9] = load_bitmap("imagens\\Placar\\PlacarN9.bmp", this->paletaJogo);
       
       this->telaAtualJogo = create_bitmap(1024, 768);
       
       this->testeImpressao = create_bitmap(200,100);
       
       this->badeiraBrasil = load_bitmap("brasil.bmp", this->paletaJogo);
       this->nomeBrasil = load_bitmap("nomeBrasil.bmp", this->paletaJogo);                   
}

void Jogo::geraImagens() {
 
       blit(this->gramado, this->telaAtualJogo, 0, 0, 0, 0, 1024, 768);
       
       masked_blit(this->bola->geraImagemBola(), this->telaAtualJogo, 0, 0, (int)this->bola->xAbsoluto, (int)this->bola->yAbsoluto , 934, 658);
       
              
       this->time1->geraImagemTime(this->telaAtualJogo, 1);
       
       this->time2->geraImagemTime(this->telaAtualJogo, 2);
       
       this->mostraGols();
       
       masked_blit(this->madeiraBaixo, this->telaAtualJogo, 0, 0, 117, 508, 1024, 768);
       
       masked_blit(this->madeiraCima, this->telaAtualJogo, 0, 0, 117, 100, 1024, 768);
       
       this->time1->geraPlacar(1, this->telaAtualJogo);
       this->time2->geraPlacar(2, this->telaAtualJogo);
       
       blit(this->testeImpressao, this->telaAtualJogo, 0, 0, 0, 0, 1024, 768); //PAULO 
              
       blit(this->telaAtualJogo, screen, 0, 0, 0, 0, 1024, 768);                   
                    
}

void Jogo::trataTeclado() {
     if(this->time1->selecao == 1) {
            this->time1->goleiro->cima = this->time1->cima;
            this->time1->goleiro->baixo = this->time1->baixo;
            this->time1->goleiro->toque = this->time1->toque;
            this->time1->goleiro->chute = this->time1->chute;
            
     }
     else if(this->time1->selecao == 2) {
            this->time1->defesa->cima = this->time1->cima;
            this->time1->defesa->baixo = this->time1->baixo;
            this->time1->defesa->toque = this->time1->toque;
            this->time1->defesa->chute = this->time1->chute;
            
     }  
     else if(this->time1->selecao == 3) {
            this->time1->meioDeCampo->cima = this->time1->cima;
            this->time1->meioDeCampo->baixo = this->time1->baixo;
            this->time1->meioDeCampo->toque = this->time1->toque;
            this->time1->meioDeCampo->chute = this->time1->chute;
     }  
     else if(this->time1->selecao == 4) {
            this->time1->ataque->cima = this->time1->cima;
            this->time1->ataque->baixo = this->time1->baixo;
            this->time1->ataque->toque = this->time1->toque;
            this->time1->ataque->chute = this->time1->chute;
     }
     
     //verifica se acertou a bola - Paulo


 //    this->chute(); 
     
    
    
    // fim chute
         
     this->time1->cima = false;
     this->time1->baixo = false;
     this->time1->toque = false;
     this->time1->chute = false;
   
     
     //time2     
     if(this->time2->selecao == 1) {
            this->time2->goleiro->cima = this->time2->cima;
            this->time2->goleiro->baixo = this->time2->baixo;
            this->time2->goleiro->toque = this->time2->toque;
            this->time2->goleiro->chute = this->time2->chute;
     }
     else if(this->time2->selecao == 2) {
            this->time2->defesa->cima = this->time2->cima;
            this->time2->defesa->baixo = this->time2->baixo;
            this->time2->defesa->toque = this->time2->toque;
            this->time2->defesa->chute = this->time2->chute;
     }  
     else if(this->time2->selecao == 3) {
            this->time2->meioDeCampo->cima = this->time2->cima;
            this->time2->meioDeCampo->baixo = this->time2->baixo;
            this->time2->meioDeCampo->toque = this->time2->toque;
            this->time2->meioDeCampo->chute = this->time2->chute;
     }  
     else if(this->time2->selecao == 4) {
            this->time2->ataque->cima = this->time2->cima;
            this->time2->ataque->baixo = this->time2->baixo;
            this->time2->ataque->toque = this->time2->toque;
            this->time2->ataque->chute = this->time2->chute;
     }    
     this->time2->cima = false;
     this->time2->baixo = false;
     this->time2->toque = false;
     this->time2->chute = false;
       
     
}

void Jogo::jogar() {
        
        while(!key[KEY_Q] == true) {
              
             this->teclado(this->time1, this->time2);
             
             this->bola->colisaoBolaCampo();//paulo
             
             
             this->trataTeclado();
             
             if(selAutomaticaTime1){
                 this->selecaoAutomatica(true);
             }
             
             if(selAutomaticaTime2){
                 this->selecaoAutomatica(false);                 
             }
             
             this->chute(this->time1->goleiro); 
             this->chute(this->time1->defesa); 
             this->chute(this->time1->meioDeCampo); 
             this->chute(this->time1->ataque); 
             
             this->colisaoBolaBonecos(this->time1->defesa);
             this->colisaoBolaBonecos(this->time1->goleiro);
             this->colisaoBolaBonecos(this->time1->meioDeCampo);
             this->colisaoBolaBonecos(this->time1->ataque);
             
             this->colisaoBolaBonecos(this->time2->defesa);
             this->colisaoBolaBonecos(this->time2->goleiro);
             this->colisaoBolaBonecos(this->time2->meioDeCampo);
             this->colisaoBolaBonecos(this->time2->ataque);
             
             this->chute(this->time1->goleiro); 
             this->chute(this->time1->defesa); 
             this->chute(this->time1->meioDeCampo); 
             this->chute(this->time1->ataque); 
             
             
             this->bola->atualizaPosicao();
             
             this->geraImagens();
             this->gol(); //esse metodo tem que ser chamado apos o gerarImagens.

             //modificado aqui
             this->selAutomaticaTime1 = true;
             this->selAutomaticaTime2 = true;                              
             //rest(100);             
             
             //para verificar onde a bola  impressa - TESTES
         //    this->bola->xAbsoluto = this->time1->defesa->bonecos[1].posX ; 
         //    this->bola->yAbsoluto = this->time1->defesa->bonecos[1].posY_esq ;             
             
        }
        

                                
             this->time1->~Time();   

        

            
        
}

//metodo que faz a seleo da barra automaticamente dependendo da posio da bola.
void Jogo::selecaoAutomatica(bool ehTime1){
     
     int sel1;
     int sel2;
     
     if( this->bola->xAbsoluto < 220 ){
                                        
         if( !(this->bola->bolaParaDireita) ){ //bola andando pra esquerda
         
             sel1 = 1;
             sel2 = 4;
         
         }else{
               
               sel1 = 2;
               sel2 = 4;
         }                
     
     }else if( this->bola->xAbsoluto < 310 ){
      //nesta posio so existira esta posio mesmo      
             sel1 = 2;
             sel2 = 4;
             
      }else if (this->bola->xAbsoluto < 400){
            
          if( !(this->bola->bolaParaDireita) ){ //bola andando pra esquerda

             sel1 = 2;
             sel2 = 4;
             
          }else{
          
             sel1 = 3;
             sel2 = 3;      
          }    
 
     }else if ( this->bola->xAbsoluto < 490){
           
        if( !(this->bola->bolaParaDireita) ){ //bola andando pra esquerda

            sel1 = 3;
            sel2 = 3;
        
        }else{
              
              sel1 = 4;
              sel2 = 3;
        }
        
     }else if ( this->bola->xAbsoluto < 580){

         if( !(this->bola->bolaParaDireita) ){ //bola andando pra esquerda
         
             sel1 = 4;
             sel2 = 3;
             
         }else{
               
               sel1 = 4;
               sel2 = 2;
               
         }
         
     }else if ( this->bola->xAbsoluto < 670) {
           
       if( !(this->bola->bolaParaDireita) ){ //bola andando pra esquerda
           
           sel1 = 4;
           sel2 = 3;
           
       }else{
             
             sel1 = 4;
             sel2 = 2;
             
       }
           
     }else if (this->bola->xAbsoluto < 760){
                 
         if( !(this->bola->bolaParaDireita) ){ //bola andando pra esquerda  
             
             sel1 = 4;
             sel2 = 2;
             
         }else{
               
               sel1 = 4;               
               sel2 = 1;
         
         }
     }
     //s atualiza a seleo do time certo
     if (ehTime1){
     
         this->time1->selecao = sel1;
     
     }else{
     
           this->time2->selecao = sel2;
     }                          
}

void Jogo::gol(){ //Rafael
     
        if(this->bola->golTime1){
                
             this->time1->gols = this->time1->gols + 1;
             this->bola->golTime1 = false;
        }
             
       if(this->bola->golTime2){
                                      
             this->time2->gols = this->time2->gols + 1;
             this->bola->golTime2 = false;
           
       }    

}


void Jogo::colisaoBolaBonecos(Barra *barra) {
     /*y = mx + n*/
     int i; 
     float pontoX, pontoY;
     float n; //coeficiente linear
     float m = tan(this->bola->angulo);
     float xInter; //ponto de interseo
     float yInter; //ponto de interseo
     float xBoneco, yBoneco, xBola, yBola, tang, vAnterior, restituicao;
     float vToqueHorizontal, vBola;
     
     this->colidiuT1 = false;
     this->colidiuT2 = false;
     bool colidiu = false;
     
     restituicao = 0.3;
     vToqueHorizontal = 5;
     
     
     float ang = this->bola->angulo;
     for(i = 0; i < barra->quantBonecos; i++) {
           
        xBoneco = barra->bonecos[i].posX;
        yBoneco = barra->bonecos[i].posY_esq;  
        xBola = this->bola->xAbsoluto;
        yBola = this->bola->yAbsoluto;
        colidiu = false;
        
        //verifica se a bola est colidindo com algum boneco
        for(pontoY = yBola; (pontoY <= yBola + 19) && !colidiu; pontoY++){ //posies y             
              for(pontoX = xBola; (pontoX <= xBola + 19) && !colidiu; pontoX++){ //posies x
                       if( (pontoX <= xBoneco && pontoX >= xBoneco - 12/*12*/) &&
                           (pontoY >= yBoneco && pontoY <= yBoneco + 14/*14*/ ) ){
                            if(barra->lado == '1'){
                                 this->colidiuT1 = true;  
                                 this->colidiuT2 = false;     
                                 colidiu = true;
                            }
                            else{
                                 this->colidiuT2 = true;  
                                 this->colidiuT1 = false;   
                                 colidiu = true;
                            }       
                            
                       }
                       else{
                            this->colidiuT1 = false;
                            this->colidiuT2 = false;  
                            colidiu = false;
                       }
              }
        }
        
        
        ang = this->bola->angulo;
        m = tan(this->bola->angulo);
        vBola= this->bola->velocidade;
        xBola = this->bola->xAbsoluto + 9.5;
        yBola = this->bola->yAbsoluto + 9.5;
        n =  yBola - m * xBola ;
       
        
        //para impresses na tela   
 /*       char a[] = "";
        itoa((int)xBola, a, 10);
        textout(testeImpressao, font, "xBola: ", 10,1, makecol(255,0,0 ) );   
        textout(testeImpressao, font, a, 80,1, makecol(255,0,0 ) );*/
        
       //1 Quadrante  
       tang = tan(ang);
        
       if(!barra->chute && !barra->toque ){
        
          if(!this->bola->bolaParaDireita && tang <= 0 ){                                
              xBoneco = barra->bonecos[i].posX;
              yBoneco = barra->bonecos[i].posY_esq;  
              xInter = (yBoneco - n)/m;  
              yInter =  m*(xBoneco) + n;     
                            
               
              if((yInter > yBoneco ) && (yInter < yBoneco + 14 + fabs((9/sin(90 - ang))) )&&
                  colidiu ){
                       if(!this->bola->bolaParaDireita) {
                          this->bola->bolaParaDireita = true; 
                       }  
                       else{
                            this->bola->bolaParaDireita = false; 
                       }                          
                       this->bola->xAbsoluto = xBoneco + 1; 
                                                  
                       this->bola->angulo = this->bola->angulo*(-1);  
                       this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2) + pow(this->bola->velocidade *cos(this->bola->angulo ),2)*restituicao ); 
                       this->bola->angulo = atan(sin(this->bola->angulo )/(cos(this->bola->angulo )*sqrt(restituicao))); 
                       
              }                  
              else if(colidiu ){
                      //para acrescentar velocidade no caso de "toque vertical"  
                      if(key[KEY_Y] && !barra->colisao ){
                      //    if((barra->lado == 1 && this->colidiuT1) || (barra->lado == 2 && this->colidiuT2) ){
                               this->bola->velocidade = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );           
                               vAnterior = this->bola->velocidade;           
                               this->bola->velocidade = sqrt(pow(this->bola->velocidade*cos(this->bola->angulo),2 ) + pow((vToqueHorizontal - this->bola->velocidade*sin(this->bola->angulo) ),2) );           
                               this->bola->angulo = acos((vAnterior*cos(this->bola->angulo))/this->bola->velocidade);
                               this->bola->yAbsoluto = yBoneco -26;//-26;     
                      //    }
                          
                      }                        
                      else{
                          this->bola->yAbsoluto = yBoneco -20; 
                          this->bola->angulo = this->bola->angulo*(-1);
                          this->bola->velocidade = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );
                          this->bola->angulo = atan((sin(this->bola->angulo )*sqrt(restituicao))/cos(this->bola->angulo ));              
                      }                                                                         
                      
              }                
                                          
        }   
        
        
        //2 Quadrante   
        else if(this->bola->bolaParaDireita && tang >= 0 ){
               
              xBoneco = barra->bonecos[i].posX -12;
              yBoneco = barra->bonecos[i].posY_esq;
              xInter = (yBoneco - n)/m;            
              yInter = m*(xBoneco) + n;       
              
                
              if(yInter > yBoneco && yInter < yBoneco + 14 + (9/sin(90 - ang)) &&  
                  colidiu ){                
                  if(this->bola->bolaParaDireita) {
                       this->bola->bolaParaDireita = false; 
                  }
                  else {
                       this->bola->bolaParaDireita = true; 
                  }      

                  this->bola->angulo = this->bola->angulo*(-1);
                  this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2) + pow(this->bola->velocidade *cos(this->bola->angulo ),2)*restituicao );  
                  this->bola->angulo = atan(sin(this->bola->angulo)/(cos(this->bola->angulo )*sqrt(restituicao)));
              }
              else if(xInter > xBoneco  && xInter < xBoneco + 12+(9/sin(ang)) && 
                   colidiu ){
              //para acrescentar velocidade no caso de "toque vertical"  
                   if(key[KEY_Y] && !barra->colisao ){
                       this->bola->velocidade = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );           
                       vAnterior = this->bola->velocidade;           
                       this->bola->velocidade = sqrt(pow(this->bola->velocidade*cos(this->bola->angulo),2 ) + pow((vToqueHorizontal - this->bola->velocidade*sin(this->bola->angulo) ),2) );           
                       this->bola->angulo = acos((vAnterior*cos(this->bola->angulo))/this->bola->velocidade);
                       this->bola->yAbsoluto = yBoneco -26;
                   }                        
                   else{
                       this->bola->yAbsoluto = yBoneco -20; 
                   }
                  
                   this->bola->angulo = this->bola->angulo*(-1);
                   this->bola->velocidade = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );
                   this->bola->angulo = atan((sin(this->bola->angulo )*sqrt(restituicao))/cos(this->bola->angulo ));              
              }                         
                                                            
        } //fim else if
        
        
        
        //3 Quadrante 
        else if(this->bola->bolaParaDireita && tang <= 0 ){
             xBoneco = barra->bonecos[i].posX -12;
             yBoneco = barra->bonecos[i].posY_esq + 14;
             xInter = (yBoneco - n)/m;            
             yInter = m*(xBoneco) + n;
             
             if(yInter > (yBoneco - (14 + (9/sin(90 - ang)))) && yInter <= yBoneco &&
                colidiu  ){
                if(this->bola->bolaParaDireita) {
                     this->bola->bolaParaDireita = false; 
                }
                else{
                     this->bola->bolaParaDireita = true; 
                }    
                n =  yBola - m * xBola ; 
                this->bola->xAbsoluto = xBoneco - 20;
                this->bola->angulo = this->bola->angulo*(-1);
                this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2) + pow(this->bola->velocidade *cos(this->bola->angulo ),2)*restituicao );  
                this->bola->angulo = atan(sin(this->bola->angulo)/(cos(this->bola->angulo )*sqrt(restituicao)));
                                
             }
             else if(xInter >= xBoneco && xInter <= xBoneco + (12 + fabs((9/sin(ang))) ) 
                     && colidiu ){                                
                   //para acrescentar velocidade no caso de "toque vertical"  
                   if(key[KEY_H] && !barra->colisao ){
                       this->bola->velocidade = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );           
                       vAnterior = this->bola->velocidade;           
                       this->bola->velocidade = sqrt(pow(this->bola->velocidade*cos(this->bola->angulo),2 ) + pow((vToqueHorizontal - this->bola->velocidade*sin(this->bola->angulo) ),2) );           
                       this->bola->angulo = acos((vAnterior*cos(this->bola->angulo))/this->bola->velocidade);
                       this->bola->yAbsoluto = yBoneco +7;
                   }                        
                   else{
                       this->bola->yAbsoluto = yBoneco +1;
                       this->bola->angulo = this->bola->angulo*(-1); 
                       this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2)*restituicao + pow(this->bola->velocidade *cos(this->bola->angulo ),2) );  
                       this->bola->angulo = atan((sin(this->bola->angulo )*sqrt(restituicao))/cos(this->bola->angulo));
                   }                  
                     
             }
             
        } //if 3 Quadrante
        
        
        
        //4 Quadrante
        else if(!this->bola->bolaParaDireita && tang >= 0){       
             xBoneco = barra->bonecos[i].posX;
             yBoneco = barra->bonecos[i].posY_esq + 14;
             xInter = (yBoneco - n)/m;            
             yInter = m*(xBoneco) + n;
             
             
             if(yInter <= yBoneco && yInter >= yBoneco - (14 + fabs((9/sin(ang)))) && 
                colidiu && xBoneco < xBola/*xBoneco <= xBola*/ ){
                if(!this->bola->bolaParaDireita) {
                     this->bola->bolaParaDireita = true; 
                }  
                else{
                     this->bola->bolaParaDireita = false; 
                }        
                n =  yBola - m * xBola ; 
                this->bola->xAbsoluto = xBoneco +1; 
                this->bola->angulo = this->bola->angulo*(-1); 
                this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2) + pow(this->bola->velocidade *cos(this->bola->angulo ),2)*restituicao ); 
                this->bola->angulo = atan(sin(this->bola->angulo )/(cos(this->bola->angulo )*sqrt(restituicao))); 
             }
             else if(colidiu ){
                  
                  if(!key[KEY_H] && !key[KEY_Y] ){
                       this->bola->yAbsoluto = yBoneco +1;
                       this->bola->angulo = this->bola->angulo*(-1);
                       this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2)*restituicao + pow(this->bola->velocidade *cos(this->bola->angulo ),2) );  
                       this->bola->angulo = atan((sin(this->bola->angulo )*sqrt(restituicao))/cos(this->bola->angulo));
                  }
                   //para acrescentar velocidade no caso de "toque vertical"  
                   if(key[KEY_H] && !barra->colisao ){
                       this->bola->velocidade = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );           
                       vAnterior = this->bola->velocidade;           
                       this->bola->velocidade = sqrt(pow(this->bola->velocidade*cos(this->bola->angulo),2 ) + pow((vToqueHorizontal - this->bola->velocidade*sin(this->bola->angulo) ),2) );           
                       this->bola->angulo = acos((vAnterior*cos(this->bola->angulo))/this->bola->velocidade);
                       this->bola->yAbsoluto = yBoneco + 7;
                       this->bola->angulo = this->bola->angulo*(-1);
                   }
                   else if(key[KEY_Y] && !barra->colisao ){//06-02-06 PAULO
                       this->bola->velocidade = 10;//sqrt(pow(this->bola->velocidade*cos(this->bola->angulo),2 ) + pow((vToqueHorizontal + this->bola->velocidade*sin(this->bola->angulo) ),2) );
                       this->bola->angulo = acos((vAnterior*cos(this->bola->angulo))/this->bola->velocidade);
                       this->bola->yAbsoluto = yBoneco -26;
                      // this->bola->xAbsoluto = 200;
                   }                        
              //     else{
              //         this->bola->yAbsoluto = yBoneco +1;
              //         this->bola->angulo = this->bola->angulo*(-1);
              //         this->bola->velocidade = sqrt( pow(this->bola->velocidade *sin(this->bola->angulo ),2)*restituicao + pow(this->bola->velocidade *cos(this->bola->angulo ),2) );  
              //         this->bola->angulo = atan((sin(this->bola->angulo )*sqrt(restituicao))/cos(this->bola->angulo));
              //     }                         

                    
             }             
             

        }
        
      } // IF barra chute e toque
    }//fim for
     
}


void Jogo:: chute(Barra *barra){ //paulo
     float xBola, yBola, xBoneco, yBoneco;
     float restituicao = 0.3;
     float vPosColisao, ganho, d;
     int i;
     ganho = 6;
     
     for(i = 0; i < barra->quantBonecos; i++){
           
          if(barra->chute && this->habilitaChuteTime01 ){
             xBola = this->bola->xAbsoluto + 9.5;
             yBola = this->bola->yAbsoluto + 9.5;                                     
             xBoneco = barra->bonecos[i].posX;
             yBoneco = barra->bonecos[i].posY_esq;
             
             if( xBola > xBoneco &&  xBola < xBoneco + 25 &&                
                 yBola >= yBoneco - 9.5 && yBola <= yBoneco + 14 + 9.5 &&                
                 this->habilitaChuteTime01 ) {
                 if(yBola >= yBoneco - 9.5 && yBola < yBoneco  ){
                    d = yBola - yBoneco;      
                    this->bola->angulo = asin(d/9.5);                     
                    this->bola->bolaParaDireita = true;   
                    vPosColisao = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );                               
                    this->bola->velocidade = vPosColisao + ganho*cos(this->bola->angulo);                
                 }
                 else if(yBola >= yBoneco && yBola <= yBoneco + 14 ){
                    this->bola->angulo = this->grauParaRadiano(0);//0;  
                    this->bola->bolaParaDireita = true;     
                    vPosColisao = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );                               
                    this->bola->velocidade = vPosColisao + ganho;              
                 }
                 else if(yBola >= yBoneco + 14 && yBola <= yBoneco + 14 + 9.5  ){
                    d = yBola - (yBoneco + 14);  
                    this->bola->angulo = asin(d/9.5); 
                    this->bola->bolaParaDireita = true;                   
                    vPosColisao = sqrt( pow(this->bola->velocidade*sin(this->bola->angulo),2)*restituicao + pow(this->bola->velocidade*cos(this->bola->angulo),2) );                               
                    this->bola->velocidade = vPosColisao + ganho*cos(this->bola->angulo);                
                 }   
                 

             }                                                                                       
          }                 
     }
           
}


float Jogo:: grauParaRadiano(float grau){
    return ((grau * 3.14159265)/180);
}


void Jogo::mostraGols(){
    if(this->time1->gols < 10 ){    
        blit(this->placar[this->time1->gols], this->telaAtualJogo, 0, 0, 74, 163, 1024, 768);        
    }else {
           blit(this->placar[0], this->telaAtualJogo, 0, 0, 74, 163, 1024, 768);
    }
    
    if (this->time2->gols < 10){
        blit(this->placar[this->time2->gols], this->telaAtualJogo, 0, 0, 819, 163, 1024, 768);
    }else {
       blit(this->placar[0], this->telaAtualJogo, 0, 0, 819, 163, 1024, 768);
    }
}
          

void Jogo::teclado(Time *t1, Time *t2) {
      
      if(key[KEY_A]) {
           t1->selecao = 1;            
           this->selAutomaticaTime1 = false;
      }else if(key[KEY_S]) {
           t1->selecao = 2;
           this->selAutomaticaTime1 = false;
      }else if(key[KEY_D]) {
           t1->selecao = 3;
           this->selAutomaticaTime1 = false;
      }else if(key[KEY_F]) {
           t1->selecao = 4;
           this->selAutomaticaTime1 = false;
      }
      
      if(key[KEY_H]) {
           t1->baixo = true;
      }
      if(key[KEY_Y]) {
           t1->cima = true;
      } 
      if(key[KEY_J]) {       
           t1->chute = true;               
    //       this->habilitaChuteTime01 = true;    //apagar 
      }
      if(key[KEY_G]) {
           t1->toque = true;
      }
      if(key[KEY_B]) {
           t1->porradaMesa = true;               
      }
      if(key[KEY_SPACE]){
           t1->chute = true; 
           this->habilitaChuteTime01 = true;
      }
      else if(!key[KEY_SPACE]){                      
       //    t1->chute = false; 
           this->habilitaChuteTime01 = false;
      }
      else if(!key[KEY_SPACE] && !key[KEY_J]){
           t1->chute = false;
           this->habilitaChuteTime01 = false;//TIRAR SE NO FUNCIONAR
      } 
      
    
      
 //     if(/*!*/key[KEY_J]) { //paulo - para no chutar se ficar segurando a tecla 'j'          
 /*          unsigned int cont = 0;
           while(key[KEY_J]){
                   
           }
           if(key[KEY_J]){
                this->habilitaChuteTime01 = false;             
           }
           else{
                this->habilitaChuteTime01 = true;             
           }
      }*/
      

                                                                
      //**************************************************************
      //Time2
      
      if(key[KEY_7_PAD]) {
           t2->selecao = 1;
           this->selAutomaticaTime2 = false;            
      }else if(key[KEY_8_PAD]) {
           t2->selecao = 2;
           this->selAutomaticaTime2 = false;
      }else if(key[KEY_9_PAD]) {
           t2->selecao = 3;
           this->selAutomaticaTime2 = false;
      }else if(key[KEY_PLUS_PAD]) {
           t2->selecao = 4;
           this->selAutomaticaTime2 = false;
      }
      
      if(key[KEY_DOWN]) {
           t2->baixo = true;
      }
      if(key[KEY_UP]) {
           t2->cima = true;
      } 
      if(key[KEY_RIGHT]) {
           t2->chute = true;
      }
      if(key[KEY_LEFT]) {
           t2->toque = true;
      }  
      
}





      
