#include "Time.h"

Time::Time(int lado, char nomeTime, int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
             
         this->goleiro = new Barra('G', 1, x1, y1, lado);
         this->defesa = new Barra('D', 2, x2, y2, lado);
         this->meioDeCampo = new Barra('M', 5, x3, y3, lado);
         this->ataque = new Barra('A', 3, x4, y4, lado);
         
         this->selecao = 0;
         this->cima = false;
         this->baixo = false;
         this->chute = false;
         this->toque = false;
         
         this->porradaMesa = false;
         
         this->gols = 0;
         
         this->nomeTime = nomeTime;
         
         this->contChute = 0;
         
         this->lado = lado;
         
         this->carregaImagensTime();
         this->imagem = create_bitmap(60,650);
         
}

Time::~Time() {
         delete this->goleiro;
         delete this->defesa;
         delete this->meioDeCampo;
         delete this->ataque;
         
}

void Time::carregaImagensTime() {
     
        this->bandeiraBrasil = load_bitmap("brasil.bmp", this->paletaTime);
        this->nomeBrasil = load_bitmap("nomeBrasil.bmp", this->paletaTime);
        
        this->bandeiraAlemanha = load_bitmap("alemanha.bmp", this->paletaTime);
        this->nomeAlemanha = load_bitmap("nomeAlemanha.bmp", this->paletaTime);            
                
        this->goleiro->carregaImagensBarra(this->nomeTime, this->lado );
        this->defesa->carregaImagensBarra(this->nomeTime, this->lado);
        this->meioDeCampo->carregaImagensBarra(this->nomeTime, this->lado);
        this->ataque->carregaImagensBarra(this->nomeTime, this->lado);
         
}

void Time::geraImagemTime(BITMAP *fundo, int time) {
    //   BITMAP *imagem = create_bitmap(80, 650);
        if(this->selecao == 1) {
           imagem = this->goleiro->geraImagemBarra(time);
           masked_blit(imagem, fundo, 0, 0, this->goleiro->posX, this->goleiro->posY, 1000, 680);
       }
       else {         
           imagem = this->goleiro->imagem[0];
           masked_blit(imagem, fundo, 0, 0, this->goleiro->posX, this->goleiro->posY, 1000, 680);
       } 
        if(this->selecao == 2) {
           imagem = this->defesa->geraImagemBarra(time);
           masked_blit(imagem, fundo, 0, 0, this->defesa->posX, this->defesa->posY, 1000, 680);
          
       }
       else {         
           imagem = this->defesa->imagem[0];
           masked_blit(imagem, fundo, 0, 0, this->defesa->posX, this->defesa->posY, 1000, 680);
           
       }        
       if(this->selecao == 3) {
           imagem = this->meioDeCampo->geraImagemBarra(time);
           masked_blit(imagem, fundo, 0, 0, this->meioDeCampo->posX, this->meioDeCampo->posY, 1000, 680);
          
       }
       else {         
           imagem = this->meioDeCampo->imagem[0];
           masked_blit(imagem, fundo, 0, 0, this->meioDeCampo->posX, this->meioDeCampo->posY, 1000, 680);
       } 
       if(this->selecao == 4) {
           imagem = this->ataque->geraImagemBarra(time);
           masked_blit(imagem, fundo, 0, 0, this->ataque->posX, this->ataque->posY, 1000, 680);
       }
       else {         
           imagem = this->ataque->imagem[0];
           masked_blit(imagem, fundo, 0, 0, this->ataque->posX, this->ataque->posY, 1000, 680);
       } 

}

void Time::geraPlacar(int time, BITMAP *telaAtualJogo) {
     if(time == 1) {
         if(this->nomeTime == 'B') {
              blit(this->bandeiraBrasil, telaAtualJogo, 0, 0, 70, 130, 1024, 768);
              masked_blit(this->nomeBrasil, telaAtualJogo, 0, 0, 70, 110, 1024, 768);
         }else if(this->nomeTime == 'A') {
              blit(this->bandeiraAlemanha, telaAtualJogo, 0, 0, 70, 130, 1024, 768);
              masked_blit(this->nomeAlemanha, telaAtualJogo, 0, 0, 70, 110, 1024, 768);
         }
     }else if(time == 2) {
         if(this->nomeTime == 'B') {
              blit(this->bandeiraBrasil, telaAtualJogo, 0, 0, 815, 130, 1024, 768);
              masked_blit(this->nomeBrasil, telaAtualJogo, 0, 0, 778, 110, 1024, 768);
         }else if(this->nomeTime == 'A') {
              blit(this->bandeiraAlemanha, telaAtualJogo, 0, 0, 815, 130, 1024, 768);
              masked_blit(this->nomeAlemanha, telaAtualJogo, 0, 0, 774, 110, 1024, 768);
         } 
     }                  
     
}
