#include "Bola.h"
#include <Math.h>
#include <Time.h>


Bola::Bola(float xAbs, float yAbs, float ang){
     
     this->xAbsoluto = xAbs;
     this->yAbsoluto = yAbs;
     this->angulo = (ang * 3.14159265)/180; //para converter de grau para radiano    
     this->colidiu = false;
     this->bolaParaDireita = true;//true; //valor inicial para teste - deve ser sorteado no incio do jogo
     this->velocidade = 3;
     this->carregaImagemBola();
     
     this->golTime1 = false;
     this->golTime2 = false;
     
}

void Bola::carregaImagemBola() {
     
      this->imagemBola = load_bitmap("imagens\\bola.bmp", this->paletaBola);             
}

BITMAP* Bola::geraImagemBola() {
//      if(!(this->golTime1 || this->golTime2)){
          return this->imagemBola;                                    
  //    }
      
}


void Bola :: atualizaPosicao(){

          float xRelativo = 0;
          float yRelativo = 0;
          int instante;

          if(this->golTime1 || this->golTime2){
              instante = time(NULL);
              while(time(NULL) < instante + 2){
                   this->xAbsoluto = 460;
                   this->yAbsoluto = 310;
                   this->velocidade = 0;                               
              }//espera 2 segundos
              this->velocidade = 2; 
          
          }else{
                                  
              if(this->angulo >= 0 && this->bolaParaDireita ){
                   xRelativo = xRelativo + this->velocidade * cos(angulo);  
                   yRelativo = yRelativo + velocidade * sin(angulo);                                                                                                         
              }
         
              else if(this->angulo >= 0 && !this->bolaParaDireita ) {
                   xRelativo = xRelativo - this->velocidade * cos(angulo);    
                   yRelativo = yRelativo + velocidade * sin(-angulo);              
              }
              
              else if(this->angulo <= 0 && this->bolaParaDireita){
                   xRelativo = xRelativo + this->velocidade * cos(angulo);    
                   yRelativo = yRelativo + velocidade * sin(angulo);    
              }
              else if(this->angulo <= 0 && !this->bolaParaDireita){
                   xRelativo = xRelativo - this->velocidade * cos(angulo);    
                   yRelativo = yRelativo + velocidade * sin(-angulo);    
              }
             
              
              
              
              this->xAbsoluto = this->xAbsoluto + xRelativo;           
              this->yAbsoluto = this->yAbsoluto + yRelativo;    
              

              
           
              if(this->velocidade <= 0){
                  this->velocidade = 0;
              } 
              
             // else{              
              //    this->velocidade = this->velocidade - 0.0018; // atrito         
               //     this->velocidade = this->velocidade - 0.0006; // atrito         
             // }
           
           }              
}

void Bola :: colisaoBolaCampo(){
             float restituicao = 1;//0.5;

             if(this->yAbsoluto < 132){ //1
                  this->yAbsoluto = 132;                            
                  this->angulo = this->angulo * (-1);                  
                  
                  if (this->velocidade <= 0){
                      this->velocidade = 0;                           
                  }
                  else{                    
                      this->velocidade = sqrt( pow(velocidade*sin(angulo),2)*restituicao + pow(velocidade*cos(angulo),2) );  
                  }
                  
                  this->angulo = atan((sin(angulo)*sqrt(restituicao))/cos(angulo));
              

             }  

             if(this->xAbsoluto > 784){ //2
                 
                 if( (this->yAbsoluto < 370) && (this->yAbsoluto > 270) ){ //a bola entrou! ui
                 
                     this->golTime1 = true;
                     
                 
                 }
                 else{
                    this->xAbsoluto = 784;                                                      
                    this->angulo = this->angulo * (-1);    
                    
                    if (this->bolaParaDireita){
                       this->bolaParaDireita = false;      
                    }
                                                         
                    
                    if (this->velocidade <= 0){
                       this->velocidade = 0;                                                 
                    }
                    else{                
                         this->velocidade = sqrt( pow(velocidade*sin(angulo),2) + pow(velocidade*cos(angulo),2)*restituicao );  
                    }
                    this->angulo = atan(sin(angulo)/(cos(angulo)*sqrt(restituicao))); 
                    
                    }// fim else                  
                               
             }

             if(this->yAbsoluto > 490){ //3
                  this->yAbsoluto = 490;                    
                  this->angulo = this->angulo * (-1);    
                  
                  if (this->velocidade <= 0){
                      this->velocidade = 0;                           
                  }
                  else{                  
                       this->velocidade = sqrt( pow(velocidade*sin(angulo),2)*restituicao + pow(velocidade*cos(angulo),2) );
                  }
                  this->angulo = atan((sin(angulo)*sqrt(restituicao))/cos(angulo));              
                  
             }
             if(this->xAbsoluto < 120){ //4

                 if( (this->yAbsoluto < 370) && (this->yAbsoluto > 270) ){ //a bola entrou! ui
                 
                     this->golTime2 = true;
                 
                 }
                 else{

                       this->xAbsoluto = 120;  
                       this->angulo = this->angulo * (-1);         
                       if (!this->bolaParaDireita){
                          this->bolaParaDireita = true;      
                       } 
                       else{
                            this->bolaParaDireita = false;      
                       }                   
                       if (this->velocidade <= 0){
                          this->velocidade = 0;                           
                       }
                       else{                 
                            this->velocidade = sqrt( pow(velocidade*sin(angulo),2) + pow(velocidade*cos(angulo),2)*restituicao );
                       }
                       
                     
                       this->angulo = atan(sin(angulo)/(cos(angulo)*sqrt(restituicao))); 
                  } //fim else
                                                                       
             }

     
}
