#include <allegro.h>
#include "Jogo.h"

PALETTE pal;
char apresentacao();


int main() {
    
    allegro_init(); 
    install_keyboard(); 
    set_color_depth(32);
    set_gfx_mode(GFX_AUTODETECT, 1024, 768, 0, 0);
    
    
    char time2;
    char time = apresentacao();
    if(time == 'A') {
        time2 = 'B';
    }else {
          time2 = 'A';
    }
    Jogo *jogo = new Jogo(time, time2);
    
    jogo->jogar();
    
    jogo->~Jogo();
    
    return 0; 
}
END_OF_MAIN()


char apresentacao() {
       BITMAP *fundo = load_bitmap("pebolim.bmp", pal);
       BITMAP *times = load_bitmap("inicio.bmp", pal);
       BITMAP *selE = load_bitmap("selecaoEsquerda.bmp", pal);
       BITMAP *selD = load_bitmap("selecaoDireita.bmp", pal);
       BITMAP *telaAtualJogo = create_bitmap(1024, 768);
       bool selecionou = false;
       char pos = 'B';
       
       blit(fundo, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
       masked_blit(times, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
       masked_blit(selE, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
       
       while(key[KEY_ENTER] == false) {
                   
           if(key[KEY_RIGHT]) {
                 blit(fundo, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
                 masked_blit(times, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
                 masked_blit(selD, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
                 pos = 'A';              
           }
           if(key[KEY_LEFT]) {
                 blit(fundo, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
                 masked_blit(times, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
                 masked_blit(selE, telaAtualJogo, 0, 0, 200, 100, 1024, 768);
                 pos = 'B';
           }              
           
           blit(telaAtualJogo, screen, 0, 0, 0, 0, 1024, 768);
       } 
       
       return pos;             
     
}

